#!/sbin/sh
rm /cache/resize_log.txt
echo "--- Script version 20-mod11" > /cache/resize_log.txt
echo "--- Setting path variable..." >> /cache/resize_log.txt
export PATH=$PATH:/system/bin:/system/xbin >> /cache/resize_log.txt
echo "--- Checking path variable..." >> /cache/resize_log.txt
echo $PATH >> /cache/resize_log.txt
echo "--- Getting current partition table" >> /cache/resize_log.txt
parted -s /dev/block/mmcblk0 "unit s" "print" > /tmp/gpt.txt
cat /tmp/gpt.txt >> /cache/resize_log.txt
echo "--- Calculating values..." >> /cache/resize_log.txt
usrdatano=`cat /tmp/gpt.txt | grep userdata | awk '{print $1}'`
intsdno=`cat /tmp/gpt.txt | grep intsd | awk '{print $1}'`
usrdatasec=`cat /tmp/gpt.txt | grep userdata | awk '{print $2}' | cut -d "s" -f "1"`
secsz=`cat /tmp/gpt.txt | grep "logical/physical" | cut -d "/" -f 3 | cut -d "B" -f "1"`
rszprpno=`cat /tmp/resize.prop | cut -d "=" -f "2"`
nwusrsize=`expr ${rszprpno} + 2`
usrsecsz=`expr ${nwusrsize} \* 1024 \* 1024 \* 1024 / ${secsz}`
usrdtndssec=`expr ${usrdatasec} + ${usrsecsz}`
intsdstrtsec=`expr ${usrdtndssec} + 1`
usrdtldndsec=`cat /tmp/gpt.txt | grep userdata | awk '{print $3}' | cut -d "s" -f "1"`
intsdndsec=`cat /tmp/gpt.txt | grep intsd | awk '{print $3}' | cut -d "s" -f "1"`
intsdsize=`expr ${intsdndsec} - ${intsdstrtsec}` >> /cache/resize_log.txt
minfatsize=66000
#intsdpart=`ls -l /dev/block/platform/mtk-msdc.0/by-name | grep intsd | awk '{print $NF}'`

AUTOMATED(){
  echo "--- Running e2fsck..." >> /cache/resize_log.txt
	e2fsck -pf /dev/block/mmcblk0p${usrdatano} >> /cache/resize_log.txt
  echo "--- Running resize2fs..." >> /cache/resize_log.txt
  resize2fs /dev/block/mmcblk0p${usrdatano} ${usrsecsz}s >> /cache/resize_log.txt
  echo "--- Deleting userdata partition..." >> /cache/resize_log.txt
	parted -s /dev/block/mmcblk0 "rm ${usrdatano}" >> /cache/resize_log.txt
  echo "--- Deleting intsd partition..." >> /cache/resize_log.txt
parted -s /dev/block/mmcblk0 "rm ${intsdno}" >> /cache/resize_log.txt
  echo "--- Creating new userdata partition..." >> /cache/resize_log.txt
	parted -s /dev/block/mmcblk0 "unit s" "mkpart primary ${usrdatasec} ${usrdtndssec}"  >> /cache/resize_log.txt
  echo "--- Creating new intsd partition..." >> /cache/resize_log.txt
	parted -s /dev/block/mmcblk0 "unit s" "mkpart primary ${intsdstrtsec} ${intsdndsec}" >> /cache/resize_log.txt
  echo "--- Naming userdata partition..." >> /cache/resize_log.txt
	parted -s /dev/block/mmcblk0 "name ${usrdatano} userdata" >> /cache/resize_log.txt
  echo "--- Naming intsd partition..." >> /cache/resize_log.txt
	parted -s /dev/block/mmcblk0 "name ${intsdno} intsd" >> /cache/resize_log.txt
  echo "--- Running e2fsck..." >> /cache/resize_log.txt
	e2fsck -pf /dev/block/mmcblk0p${usrdatano} >> /cache/resize_log.txt
  echo "--- Running resize2fs..." >> /cache/resize_log.txt
  resize2fs /dev/block/mmcblk0p${usrdatano} >> /cache/resize_log.txt
  if [ ${intsdsize} -lt ${minfatsize} ]; then
    echo "---Reformatting intsd as FAT16 (intsd size is less than 33,000B)..." >> /cache/resize_log.txt
    parted -s /dev/block/mmcblk0 "mkfs ${intsdno} fat16" >> /cache/resize_log.txt
  else
    echo "---Reformatting intsd as FAT32..." >> /cache/resize_log.txt
    parted -s /dev/block/mmcblk0 "mkfs ${intsdno} fat32" >> /cache/resize_log.txt
  fi
}
AUTOMATED ${1:-nwusrsize}
echo "-----" >> /cache/resize_log.txt
printf "userdata number: ${usrdatano}\nintsd number: ${intsdno}\nuserdata start sector: ${usrdatasec}\nuserdata size ${usrsecsz} sectors\nintsd start sector: ${intsdstrtsec}\nintsd end sector: ${intsdndsec}\nintsd size: ${intsdsize}\nfat32 minimum partition size: ${minfatsize}\n" >> /cache/resize_log.txt
echo "-----" >> /cache/resize_log.txt
echo "--- Printing new partition table..." >> /cache/resize_log.txt
parted -s /dev/block/mmcblk0 "unit s" "print" >> /cache/resize_log.txt
echo "--- Running e2fsck..." >> /cache/resize_log.txt
e2fsck -pf /dev/block/mmcblk0p${usrdatano} >> /cache/resize_log.txt
echo "--- Running resize2fs..." >> /cache/resize_log.txt
resize2fs /dev/block/mmcblk0p${usrdatano} >> /cache/resize_log.txt
echo "--- Finished!" >> /cache/resize_log.txt
chmod 666 /cache/resize_log.txt